#include <SDL.h>
#include <xmp.h>
#include <stdbool.h>

int sonando;
char * modulo = "res/aladin.mod";

static void rellenarAudio(void *udata, Uint8 *stream, int len)
{
  if (xmp_play_buffer((xmp_context)udata, stream, len, 0) < 0){ sonando = 0; }
}


static int sdl_init(xmp_context ctx) {
  if (SDL_Init(SDL_INIT_AUDIO) < 0) { printf("No se ha podido inicializar: %s\n", SDL_GetError()); return 1; }
  SDL_AudioSpec a;
  a.freq = 44100;
  a.format = AUDIO_S16;
  a.channels = 2;
  a.samples = 2048;
  a.callback = rellenarAudio;
  a.userdata = ctx;
  if (SDL_OpenAudio(&a, NULL) < 0) { printf("No se ha podido inicializar el dispositivo de audio: %s\n", SDL_GetError());	return 1; }
  return 0;
}

int main(int argc, char **argv) {
  SDL_Event evento;
  bool quit = false;
  SDL_Window * ventana;
  SDL_Init(SDL_INIT_VIDEO);
  ventana = SDL_CreateWindow("Modulo sonando de fondo",SDL_WINDOWPOS_UNDEFINED,SDL_WINDOWPOS_UNDEFINED,320,240,SDL_WINDOW_OPENGL);
  if (ventana == NULL) { printf("No se pudo crear la ventana: %s\n", SDL_GetError());	return 1; }

  xmp_context ctx;
  ctx = xmp_create_context();
  sdl_init(ctx);
  xmp_load_module(ctx, modulo);
  xmp_start_player(ctx, 44100, 0);
  sonando = 1;
  SDL_PauseAudio(0);

  while (!quit) {
    SDL_WaitEvent(&evento);
    switch (evento.type) {
    case SDL_QUIT:
      xmp_end_player(ctx);
      xmp_free_context(ctx);
      SDL_CloseAudio();
      quit = true;
      break;
    }
  }
}
